// Generated by CoffeeScript 1.9.3
(function() {
  var Processor, processor;

  Processor = (function() {
    function Processor(selector) {
      var j, results;
      this.root = $(selector);
      this.columnLabels = ['', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'];
      this.rowLabels = (function() {
        results = [];
        for (j = 0; j < 100; j++){ results.push(j); }
        return results;
      }).apply(this);
      this.selected = $('');
      this.buttons = [
        ['help', 'Nápověda', this.showHelp], [
          'bold', 'Tučně', (function(_this) {
            return function() {
              return _this.toggleClass('b');
            };
          })(this)
        ], [
          'italic', 'Kurzíva', (function(_this) {
            return function() {
              return _this.toggleClass('i');
            };
          })(this)
        ], [
          'underline', 'Podtržené', (function(_this) {
            return function() {
              return _this.toggleClass('u');
            };
          })(this)
        ], [
          'border', 'Ohraničení', (function(_this) {
            return function() {
              return _this.toggleClass('border');
            };
          })(this)
        ], [
          'size-plus', 'A+', (function(_this) {
            return function() {
              return _this.sizePlus();
            };
          })(this)
        ], [
          'size-minus', 'A-', (function(_this) {
            return function() {
              return _this.sizeMinus();
            };
          })(this)
        ], [
          'remove-format', 'Deformátovat', (function(_this) {
            return function() {
              return _this.deformat();
            };
          })(this)
        ], [
          'delete-row', 'X řádek', (function(_this) {
            return function() {
              return _this.deleteRow();
            };
          })(this)
        ], [
          'delete-column', 'X sloupec', (function(_this) {
            return function() {
              return _this.deleteColumn();
            };
          })(this)
        ]
      ];
      this.selects = [
        [
          'font', [['f1', 'Georgia'], ['f2', 'Times New Roman'], ['f3', 'Trebuchet MS'], ['f4', 'Courier New'], ['f-ugly', 'Comic Sans MS']], (function(_this) {
            return function(e) {
              return _this.changeFont(e);
            };
          })(this)
        ]
      ];
      this.colors = [
        [
          'color', 'red black green yellow blue'.split(' '), 'písmo', (function(_this) {
            return function(e) {
              return _this.changeColor(e, 'color');
            };
          })(this)
        ], [
          'background-color', 'red black green yellow blue'.split(' '), 'pozadí', (function(_this) {
            return function(e) {
              return _this.changeColor(e, 'background-color');
            };
          })(this)
        ]
      ];
    }

    Processor.prototype.init = function() {
      this.buildUi();
      this.initEditable();
      return this.initFastEditation();
    };

    Processor.prototype.initEditable = function() {
      this.body.on('click', 'td input', (function(_this) {
        return function(e) {
          _this.selected = $(e.target);
          _this.body.find('.focus').removeClass('focus');
          _this.selected.addClass('focus');
          _this.edit.val(_this.selected.val());
          _this.edit.focus();
          return _this.toolbar.find('.font').val(_this.selected.data('font') || 'f1');
        };
      })(this));
      return this.edit.on('input', (function(_this) {
        return function(e) {
          var $this;
          $this = $(e.target);
          _this.selected.val($this.val());
          _this.selected.attr('value', $this.val());
          return _this.recompute();
        };
      })(this));
    };

    Processor.prototype.buildUi = function() {
      this.toolbar = $('<div />', {
        "class": 'toolbar'
      }).appendTo(this.root);
      this.edit = $('<input />', {
        "class": 'edit',
        type: 'text'
      }).appendTo(this.root);
      this.table = $('<table />').appendTo(this.root);
      this.head = $('<thead />').appendTo(this.table);
      this.body = $('<tbody />').appendTo(this.table);
      this.buildCells(this.body, this.head);
      return this.buildToolbar(this.toolbar);
    };

    Processor.prototype.buildCells = function(body, head) {
      var column, headRow, j, k, l, len, len1, len2, ref, ref1, ref2, results, row, x, y;
      headRow = $('<tr />');
      ref = this.columnLabels;
      for (x = j = 0, len = ref.length; j < len; x = ++j) {
        column = ref[x];
        $('<th />').text(column).appendTo(headRow);
      }
      head.append(headRow);
      ref1 = this.rowLabels;
      results = [];
      for (y = k = 0, len1 = ref1.length; k < len1; y = ++k) {
        row = ref1[y];
        row = $('<tr />');
        $('<th />').text(y + 1).appendTo(row);
        ref2 = this.columnLabels;
        for (x = l = 0, len2 = ref2.length; l < len2; x = ++l) {
          column = ref2[x];
          $('<td />', {
            'data-x': x,
            'data-y': y
          }).html($('<input type="text" tabindex="0"/>')).appendTo(row);
        }
        results.push(body.append(row));
      }
      return results;
    };

    Processor.prototype.buildToolbar = function(toolbar) {
      var _, button, color, datalist, i, input, j, k, l, len, len1, len2, len3, len4, m, n, option, ref, ref1, ref2, ref3, ref4, results, select, selectEl;
      ref = this.buttons;
      for (i = j = 0, len = ref.length; j < len; i = ++j) {
        button = ref[i];
        $('<button />').addClass(button[0]).text(button[1]).appendTo(toolbar).click(button[2]);
      }
      ref1 = this.selects;
      for (i = k = 0, len1 = ref1.length; k < len1; i = ++k) {
        select = ref1[i];
        selectEl = $('<select />').addClass(select[0]).appendTo(toolbar).on('change', select[2]);
        ref2 = select[1];
        for (_ = l = 0, len2 = ref2.length; l < len2; _ = ++l) {
          option = ref2[_];
          $('<option />', {
            value: option[0]
          }).text(option[1]).appendTo(selectEl);
        }
      }
      ref3 = this.colors;
      results = [];
      for (i = m = 0, len3 = ref3.length; m < len3; i = ++m) {
        color = ref3[i];
        input = $('<input />', {
          list: color[0],
          "class": color[0],
          type: 'text',
          placeholder: color[2]
        }).appendTo(toolbar).on('input', color[3]);
        input.on('focus', function() {
          return input.val('');
        });
        datalist = $('<datalist />', {
          id: color[0]
        });
        ref4 = color[1];
        for (_ = n = 0, len4 = ref4.length; n < len4; _ = ++n) {
          option = ref4[_];
          $('<option />', {
            value: option
          }).appendTo(datalist);
        }
        results.push(datalist.appendTo(this.root));
      }
      return results;
    };

    Processor.prototype.showHelp = function() {
      return window.open('help.html');
    };

    Processor.prototype.sizePlus = function() {
      var size;
      size = parseInt(this.selected.css('font-size')) + 2;
      this.selected.css('font-size', size);
      return this.edit.focus();
    };

    Processor.prototype.sizeMinus = function() {
      var size;
      size = parseInt(this.selected.css('font-size')) - 2;
      this.selected.css('font-size', size);
      return this.edit.focus();
    };

    Processor.prototype.changeFont = function(e) {
      var val;
      val = $(e.target).val();
      this.selected.toggleClass(val).data('font', val);
      return this.edit.focus();
    };

    Processor.prototype.changeColor = function(e, property) {
      var color;
      color = $(e.target).val();
      if (this.isValidCssColor(color)) {
        this.selected.css(property, color);
        return this.edit.focus();
      }
    };

    Processor.prototype.deformat = function() {
      this.selected.removeClass().addClass('focus');
      this.selected.css({
        'font-size': '',
        'background-color': '',
        'color': ''
      });
      this.toolbar.find('.font').val('f1');
      return this.edit.focus();
    };

    Processor.prototype.toggleClass = function(_class) {
      this.selected.toggleClass(_class);
      return this.edit.focus();
    };

    Processor.prototype.deleteRow = function() {
      this.selected.closest('tr').remove();
      return this.body.find('tr th').each(function(i, el) {
        return $(el).text(i + 1);
      });
    };

    Processor.prototype.deleteColumn = function() {
      var selector, x;
      x = parseInt(this.selected.parent().data('x'));
      selector = 'tr td[data-x=' + x + ']';
      return this.body.find(selector).remove();
    };

    Processor.prototype.initFastEditation = function() {
      return $(document).keydown((function(_this) {
        return function(e) {
          var ref, x, y;
          if ((ref = e.which) !== 37 && ref !== 38 && ref !== 39 && ref !== 40 && ref !== 9 && ref !== 13) {
            return;
          }
          if (e.which === 13) {
            e = $.Event('keydown');
            e.which = 40;
            $(document).trigger(e);
            _this.recompute();
            return;
          }
          if (e.which === 9) {
            e = $.Event('keydown');
            e.which = 39;
            $(document).trigger(e);
            _this.recompute();
            return;
          }
          x = parseInt(_this.selected.parent().data('x'));
          y = parseInt(_this.selected.parent().data('y'));
          switch (e.which) {
            case 37:
              x--;
              break;
            case 38:
              y--;
              break;
            case 39:
              x++;
              break;
            case 40:
              y++;
          }
          _this.selected.removeClass('focus');
          _this.selected = _this.body.find('td[data-x=' + x + '][data-y=' + y + '] input').addClass('focus');
          _this.edit.val(_this.selected.val()).focus();
          return _this.recompute();
        };
      })(this));
    };

    Processor.prototype.recompute = function() {
      return this.body.find('td input[value^="="]').each(function(i, el) {
        var val;
        el = $(el);
        val = el.val().substring(1);
        return el.val(val);
      });
    };

    Processor.prototype.isValidCssColor = function(color) {
      var image, isValid;
      isValid = /^#[0-9A-F]{6}$/i.test(color);
      if (isValid) {
        return true;
      }
      if (color === 'inherit' || color === '' || color === 'transparent') {
        return false;
      }
      image = document.createElement("img");
      image.style.color = "rgb(0, 0, 0)";
      image.style.color = color;
      if (image.style.color !== "rgb(0, 0, 0)") {
        return true;
      }
      image.style.color = "rgb(255, 255, 255)";
      image.style.color = color;
      return image.style.color !== "rgb(255, 255, 255)";
    };

    return Processor;

  })();

  processor = new Processor('.root');

  processor.init();

}).call(this);

//# sourceMappingURL=main.js.map
